/* Copyright (C) 2002-2011 VA007219 */
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <commctrl.h>

#ifndef INVALID_FILE_ATTRIBUTES
#define INVALID_FILE_ATTRIBUTES ((DWORD)-1)
#endif
#ifdef BCC32
typedef unsigned long _RTLENTRY _EXPFUNC uintptr_t;
#endif
#include "resource.h"
#ifdef UNICODE
int iskanji(int x);
#else
#define iskanji(x) IsDBCSLeadByte((BYTE)x)
#endif

#define STRINGIFY(s)   STRINGIFY_(s)
#define STRINGIFY_(s)  #s
#define LINE STRINGIFY(__LINE__)
#define TLINE _T(LINE)

#define GUISUB

int lasterror = 0;

#ifdef DEBUG
int dbgprintf(_TCHAR *fmt,...);
#endif
int msgbox(HWND hWnd,UINT uType,_TCHAR *fmt, ...);
_TCHAR *errmsg(_TCHAR *buf,int size,_TCHAR *fmt, ...);
DWORD lasterr(_TCHAR *fmt, ...);
_TCHAR *getinikey(_TCHAR *av0,_TCHAR *section,_TCHAR *key);
int globmain(int argc,_TCHAR **argv);
int ckbrk(void);
_TCHAR *newname(_TCHAR *dir,_TCHAR *name);
int std_istalpha(int c);
void dfdlog(char *fmt, ...);

extern int lasterror;
extern _TCHAR *pgname0;
extern _TCHAR fullav0[LONGMAX_PATH + 1];
extern LPTSTR CantCreateFolderName;
extern LPTSTR ExistFolderName;
extern LPTSTR Step;
extern LPTSTR ContAbort;
extern LPTSTR Percent;
extern LPTSTR Lock;
extern int iflag;

_TUCHAR *buff;

_TCHAR dirpath1[LONGMAX_PATH + 1];
_TCHAR dirpath2[LONGMAX_PATH + 1];
_TCHAR option1[17]; /*-lkgm[s|drztpqani] */
_TCHAR *option2; /* -e ext */
static int pathflag;
HWND g_hWnd;
int idsts;
int idolsts;
int idpercent;
int idnumbers;
int *pstop;

static _TCHAR stsbuf[4097 + LONGMAX_PATH];

void stssub(_TCHAR *s)
{
    _TCHAR *p;

    while ( _tcslen(stsbuf) + _tcslen(s) >= sizeof stsbuf / sizeof stsbuf[0] ) {
        p = _tcschr(stsbuf,'\n');
        if ( p == NULL ) {
            _tcscpy(stsbuf,s);
            SetDlgItemText(g_hWnd, idsts, stsbuf);
            return;
        }
        p++;
        memmove(stsbuf,p,(_tcslen(p) + 1) * sizeof(_TCHAR));
    }
    _tcscat(stsbuf,s);
    SetDlgItemText(g_hWnd, idsts, stsbuf);
    return;
}

/* sub thread */
int sts_printf(FILE *fp,const _TCHAR *format,...)
{
    va_list argp;
    int sts;
    int len;
    int m;
    _TCHAR c;
    _TCHAR *p;
    _TCHAR *q;
static _TCHAR buffer[2048 + LONGMAX_PATH];
static _TCHAR obuffer[2048 * 2 + LONGMAX_PATH];
    int ret;

    ZeroMemory(buffer,sizeof buffer);
    ZeroMemory(obuffer,sizeof obuffer);
/*dbgprintf(TLINE _T("sts_printf(format=%s)"),format);
*/
    if ( format != NULL && *format != 0 ) {
        va_start(argp, format);
        len = _vsntprintf(buffer,(2048 * 2 + LONGMAX_PATH) * sizeof(_TCHAR) - 1,format,argp);
        va_end(argp);
    }
/*dbgprintf(TLINE _T(" len=%d)"),len);
*/
    if ( len <= 0 ) {
        ret = -1;
        goto end;
    }
    p = buffer;
    q = obuffer;
    m = 0;
    while ( *p ) {
        c = *p;
        if ( c == '\n' ) {
            *q = '\r';
            q++;
            m++;
        }
        *q = c;
        p++;
        q++;
        m++;
    }
    *q = 0;
/*dbgprintf(_T("obuffer=%s"),obuffer);
*/
    stssub(obuffer);
    ret = 0;
  end:;
    return ret;
}

_TCHAR *newname(_TCHAR *dir,_TCHAR *name)
{
    int n;
    _TCHAR *p;

    n = _tcslen(name);
    if ( (_tcscmp(dir,_T("\\")) == 0 || _tcscmp(dir,_T("/")) == 0) ) { /* "\" -> "\name" */
        p = malloc((n + 2) * sizeof(_TCHAR));
        _stprintf(p,_T("\\%s"),name);
    } else if ( std_istalpha(*dir) && *(dir + 1) == ':' &&
                *(dir + 2) == '\0') { /* "a:"  -> "a:name" */
        p = malloc((n + 3) * sizeof(_TCHAR));
        _stprintf(p,_T("%s%s"),dir,name);
    } else if ( std_istalpha(*dir) && *(dir + 1) == ':' &&
                (*(dir + 2) == '\\' || *(dir + 2) == '/') && *(dir + 3) == '\0') { /* "a:\"  -> "a:\name" */
        p = malloc((n + 4) * sizeof(_TCHAR));
        _stprintf(p,_T("%s%s"),dir,name);
    } else if ( *dir == 0 ) {
        p = malloc((n + 1) * sizeof(_TCHAR));
        _stprintf(p,_T("%s"),name);
    } else {
        p = malloc((_tcslen(dir) + n + 2) * sizeof(_TCHAR));
        _stprintf(p,_T("%s\\%s"),dir,name);
    }
    return p;
}

_TCHAR *dirname(_TCHAR *x)
{
    _TCHAR *s;
    _TCHAR *p;
    _TCHAR *q;
    int c;

    if ( (p = s = _tcsdup(x)) == NULL ) {
#ifndef GUISUB
        _ftprintf(stderr,_T("%s: inadequate memory.\n"),pgname0);
        return NULL;
#else
        msgbox(NULL,MB_OK | MB_ICONWARNING,_T("%s: inadequate memory."),pgname0);
        sts_printf(NULL,_T("%s: inadequate memory."),pgname0);
        return NULL;
#endif
    }
    if ( (*p == '\\' || *p == '/') && (*(p + 1) == '\\' || *(p + 1) == '/') ) { /* \\xxx */
        p += 2;
    } else if ( (*p == '\\' || *p == '/') ) { /* \xxx */
        p += 1;
    } else if ( std_istalpha(*p) && *(p + 1) == ':' && (*(p + 2) == '\\' || *(p + 2) == '/') ) { /* a:\xxx */
        p += 3;
    } else if ( std_istalpha(*p) && *(p + 1) == ':' ) { /* a:xxx */
        p += 2;
    }
    q = p;
    while ( (c = *p) != '\0' ) {
       if ( (c == '\\'  || c == '/') ) {
           q = p;
       } else if ( iskanji(c) ) {
           if ( *(p + 1) != '\0' ) {
               p++;
           /*
           } else {
               _ftprintf(errout,_T("%s: %s: bad filename.\n"),pgname0,s);
               exit (1);
           */
           }
       }
       p++;
    } 
    *q = '\0';
    return s;
}

/* main thread */
int setpath1(HWND hWnd,_TCHAR *buf,_TCHAR **msg)
{
    if ( sizeof dirpath1 / sizeof dirpath1[0] > _tcslen(buf) + 1 ) {
        _tcscpy(dirpath1,buf);
        return 0;
    } else {
        lasterror = ERROR_BUFFER_OVERFLOW;
        msgbox(hWnd,MB_OK | MB_ICONWARNING,_T("%s: "), buf);
        *msg =  CantCreateFolderName;
        return 3;
    }
}

/* main thread */
int setpath2(HWND hWnd,_TCHAR *buf,_TCHAR **msg)
{
    if ( sizeof dirpath2 / sizeof dirpath2[0] > _tcslen(buf) + 1 ) {
        _tcscpy(dirpath2,buf);
        return 0;
    } else {
        lasterror = ERROR_BUFFER_OVERFLOW;
        msgbox(hWnd,MB_OK | MB_ICONWARNING,_T("%s: "), buf);
        *msg =  CantCreateFolderName;
        return 3;
    }
}

/* main thread */
int setflags(_TCHAR *flag1,_TCHAR *flage)
{
    _sntprintf(option1,sizeof option1 / sizeof option1[0] - 1,_T("-lkgm%s"),flag1);
    if ( flage != NULL ) {
        if ( option2 != NULL ) {
            free(option2);
        }
        option2 = malloc((_tcslen(flage) + 1) * sizeof (_TCHAR));
        if ( option2 == NULL ) return 1;
        _tcscpy(option2,flage);
    } else {
        option2 = NULL;
    }
    return 0;
}

static HWND hWnd_progress;


/* main thread */
int startup(HWND hWnd,int id)
{
    option2 = NULL;
    stsbuf[0] = 0;
    hWnd_progress = GetDlgItem(hWnd,id);
    return 0;
}

/* main thread */
int fixup(HWND hWnd,_TCHAR **msg)
{
    dirpath1[0] = 0;
    dirpath2[0] = 0;
    stsbuf[0] = 0;
    return 0;
}

/* sub thread */
int ckbrk(void)
{
/*dbgprintf(_T("ckbrk=%d"),*pstop);
*/
    return *pstop;
}

/* sub thread */
int dfdsub(HWND hWnd,int id1,int id2,int id3,int id4,int *pstopflag)
{
static _TCHAR stsmsg[LONGMAX_PATH + 512];
    _TCHAR *pmsg;
    DWORD sts;
    FILE *fp;
    _TCHAR buf[180];
    _TCHAR *p;
    int i;
    int n;
    int ret = 0;
    int argc;
    _TCHAR *argv[7];
static _TCHAR cdir[LONGMAX_PATH + 1];

// LOG("dfdsub.c LINE=%d dfdsub(HWND hWnd=%d,int id1=%d,int di2=%d,int id3=%d,int id4=%d,int *pstopflag=%p)",__LINE__,hWnd,id1,id2,id3,id4,pstopflag);

#if 0
    for ( i = 0 ; i < 10 ; i++ ) {
        if ( *pstopflag ) {
            return 0;
        }
/*dbgprintf(_T("Sleep(500)=%d"),i);
*/
        _sntprintf(stsmsg,sizeof stsmsg / sizeof stsmsg[0] - 1,_T("Sleep(500)=%d"),i);
        SetDlgItemText(hWnd, id1, stsmsg);
        Sleep(500);
    }
    return 0;
#else
    g_hWnd = hWnd;
    idsts = id1;
    idolsts = id2;
    idpercent = id3;
    idnumbers = id4;
    pstop = pstopflag;
    argv[0] = pgname0;
    argv[1] = option1;
    if ( option2 == NULL ) {
        argc = 2;
    } else {
        argv[2] = _T("-e");
        argv[3] = option2;
        argc = 4;
    }
    argv[argc] = dirpath1;
    argc++;
    argv[argc] = dirpath2;
    argc++;
    argv[argc] = NULL;
/*dbgprintf(_T("globmain(argc=%d,argv) 0:%s 1:%s 2:%s 3:%s"),argc,argv[0],argv[1],argv[2],argv[3]);
*/
    ret = dfdmain(argc,argv);
    if ( ret == 54 ) {
        GetCurrentDirectory(sizeof cdir / sizeof cdir[0] - 1, cdir);
        SetDlgItemText(hWnd, idolsts, Lock);
        sts_printf(NULL,_T("%s: %s\n"),cdir,Lock);
    }
// LOG("dfdsub.c LINE=%d dfdsub()=%d *pstopflag=%d",__LINE__,ret,*pstopflag);

    return ret; /*0:nomal 1:stopflag 2:not execute 3:error stop */
#endif
}


int u_tprintf(const _TCHAR *format,...)
{
    va_list argp;
    int sts;
    int len;
    int m;
    _TCHAR c;
    _TCHAR *p;
    _TCHAR *q;
static _TCHAR buffer[2048 + LONGMAX_PATH];
static _TCHAR obuffer[2048 * 2 + LONGMAX_PATH];
    int ret;

    ZeroMemory(buffer,sizeof buffer);
    ZeroMemory(obuffer,sizeof obuffer);
    if ( format != NULL && *format != 0 ) {
        va_start(argp, format);
        len = _vsntprintf(buffer,(2048 + LONGMAX_PATH) * sizeof(_TCHAR) - 1,format,argp);
        va_end(argp);
    }
/*dbgprintf(_T("sts_printf(format=%s)"),format);
*/
    if ( len <= 0 ) {
        ret = -1;
        goto end;
    }
/*dbgprintf(_T("_vsntprintf(buffer=%s)=%d"),buffer,len);
*/
    p = buffer;
    q = obuffer;
    m = 0;
    while ( *p ) {
        c = *p;
        if ( c == '\n' ) {
            *q = '\r';
            q++;
            m++;
        }
        *q = c;
        p++;
        q++;
        m++;
    }
    *q = 0;
    stssub(obuffer);
    ret = 0;
  end:;
    return ret;
}

int percent(_TCHAR *p,int i)
{
    _TCHAR buf[20];
    LRESULT sts;
static int bar = 0;

    if ( i < 0 ) {
        SetDlgItemText(g_hWnd, idolsts, p);
        buf[0] = 0;
        SetDlgItemText(g_hWnd, idpercent, buf);
        if ( bar ) {
            sts = SendMessage(      // returns LRESULT in lResult
                 hWnd_progress, // handle to destination control
                 (UINT)PBM_SETPOS,      // message ID
                 (WPARAM)0,      // = (WPARAM) (int) nNewPos;
                 (LPARAM)0      // = 0; not used, must be zero
            );
            bar = 0;
        }
    } else {
        _sntprintf(buf,sizeof buf / sizeof buf[0] - 1,Percent,i);
        buf[sizeof buf / sizeof buf[0] - 1] = 0;
        SetDlgItemText(g_hWnd, idpercent, buf);
        if ( i < 10 || iflag ) bar = 1;
        if ( bar ) {
            sts = SendMessage(      // returns LRESULT in lResult
                 hWnd_progress, // handle to destination control
                 (UINT) PBM_SETPOS,      // message ID
                 (WPARAM) i,      // = (WPARAM) (int) nNewPos;
                 (LPARAM) 0      // = 0; not used, must be zero
            );
        }
    }
    return 0;
}

int numbers(int samecount,int difcount,__int64 sizecount)
{
    _TCHAR buf[60];
    _TCHAR size[30];

    if ( sizecount < 102400 ) {
        _sntprintf(size,sizeof size / sizeof size[0] - 1,_T("%I64dB"),sizecount);
    } else if ( sizecount < 104857600 ) {
        _sntprintf(size,sizeof size / sizeof size[0] - 1,_T("%-.2fKB"),sizecount / 1024.0);
    } else if ( sizecount < 107374182400 ) {
        _sntprintf(size,sizeof size / sizeof size[0] - 1,_T("%-.2fMB"),sizecount / 1048576.0);
    } else {
        _sntprintf(size,sizeof size / sizeof size[0] - 1,_T("%-.2fGB"),sizecount / 1073741824.0);
    }
    if ( difcount ) {
        _sntprintf(buf,sizeof buf / sizeof buf[0] - 1,_T("%u %u %u %s"),samecount+difcount,samecount,difcount,size);
    } else {
        _sntprintf(buf,sizeof buf / sizeof buf[0] - 1,_T("%u   %s"),samecount,size);
    }
    SetDlgItemText(g_hWnd, idnumbers, buf);
    return 0;
}

int viewdir(_TCHAR *p)
{
    SetDlgItemText(g_hWnd, idolsts, p);
    return 0;
}
