/* Copyright (C) 2002-2011 VA007219 */
/*
  define USEHELP   not expand wildcard "/?"
  undef  USEHELP   expand wildcard "/?" as "\a","\b",...
  define WIN32     for win32ap
  undef  WIN32     for dos
  define STATIC    global function  dirname newname STATIC=
  undef  STATIC    local function dirname newname STATIC=static
*/
#ifdef STATIC
#undef STATIC
#define STATIC
#else
#define STATIC static
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#ifdef LSI_C
#include <jctype.h>
#else
#ifdef WIN32
#include <windows.h>
#include <tchar.h>
#ifndef UNICODE
#define iskanji(x) IsDBCSLeadByte((BYTE)x)
#else
int iskanji(int x)
{
   if ( x >=0xd800 && x <= 0xdbff ) {
        return 1;
   } else {
       return 0;
   }
}
#undef _ftprintf
#define _ftprintf u_ftprintf
#undef _tprintf
#define _tprintf u_tprintf
int u_ftprintf(FILE *fp,const _TCHAR *format,...);
int u_tprintf(const _TCHAR *format,...);
#endif
#else
#define iskanji(x) ( ((x) >= 0x81 && (x) <= 0x9f) || ((x) >= 0xe0 && (x) <= 0xfc) )
/* SBCS  #define iskanji 0 */
#define _TCHAR char
#define _tcsdup strdup
#define _tcslen strlen
#define _tcscmp strcmp
#define _tcscpy strcpy
#define _tprintf printf
#define _ftprintf fprintf
#define _stprintf sprintf
#define _istalpha isalpha
#endif
#endif

#undef main

extern int globmain(int,_TCHAR **);

_TCHAR *pgname;

STATIC _TCHAR *dirname(_TCHAR *p)
{
    _TCHAR *s;
    _TCHAR *q;
    int c;

    if ( (p = s = _tcsdup(p)) == NULL ) {
        _ftprintf(stderr,_T("%s: inadequate memory.\n"),pgname);
        exit(1);
    }
    if ( (*p == '\\' || *p == '/') && (*(p + 1) == '\\' || *(p + 1) == '/') ) { /* \\xxx */
        p += 2;
    } else if ( (*p == '\\' || *p == '/') ) { /* \xxx */
        p += 1;
    } else if ( _istalpha(*p) && *(p + 1) == ':' && (*(p + 2) == '\\' || *(p + 2) == '/') ) { /* a:\xxx */
        p += 3;
    } else if ( _istalpha(*p) && *(p + 1) == ':' ) { /* a:xxx */
        p += 2;
    }
    q = p;
    while ( (c = *p) != '\0' ) {
       if ( (c == '\\' || c == '/') ) {
           q = p;
       } else if ( iskanji(c) ) {
           if ( *(p + 1) != '\0' ) {
               p++;
           /*
           } else {
               _ftprintf(errout,_T("%s: %s: bad filename.\n"),pgname,s);
               exit (1);
           */
           }
       }
       p++;
    } 
    *q = '\0';
    return s;
}

STATIC _TCHAR *newname(_TCHAR *dir,_TCHAR *name)
{
    int n;
    _TCHAR *p;

    n = _tcslen(dir) + _tcslen(name) + 2;
    p = malloc(n * sizeof(_TCHAR));
    if ( *dir == 0 ) { /* "" -> "name" */
        _stprintf(p,_T("%s"),name);
    } else if ( (_tcscmp(dir,_T("\\")) == 0 || _tcscmp(dir,_T("/")) == 0) ) { /* "\" -> "\name" */
        _stprintf(p,_T("\\%s"),name);
    } else if ( _istalpha(*dir) && *(dir + 1) == ':' && *(dir + 2) == '\0') { /* "a:"  -> "a:name" */
        _stprintf(p,_T("%s%s"),dir,name);
    } else if ( _istalpha(*dir) && *(dir + 1) == ':' && (*(dir + 2) == '\\' || *(dir + 2) == '/') && *(dir + 3) == '\0') { /* "a:\"  -> "a:\name" */
        _stprintf(p,_T("%s%s"),dir,name);
#ifdef UNICODE
    } else if ( _tcsncmp(dir,_T("\\\\?\\"),4) == 0 && _istalpha(*(dir + 4)) && *(dir + 5) == ':' && (*(dir + 6) == '\\' || *(dir + 6) == '/') && *(dir + 7) == '\0') { /* "\\?\a:\"  -> "\\?\a:\name" */
        _stprintf(p,_T("%s%s"),dir,name);
    } else if ( _tcsncmp(dir,_T("\\\\?\\"),4) == 0 && _istalpha(*(dir + 4)) ) { /* "\\?\unc~"  -> "\\?\unc~\name" */
        _stprintf(p,_T("%s\\%s"),dir,name);
#endif
    } else {
        _stprintf(p,_T("%s\\%s"),dir,name);
    }
/*
_tprintf(_T(":newname(%s,%s) => %s\n"),dir,name,p);
*/
    return p;
}

static int ckglob(_TCHAR *p)
{
    int c;

#ifdef USEHELP
    if ( ((c = *p) == '/' || c == '-') && *(p+1) == '?' && *(p+2) == 0 ) return 0;
#endif
#ifdef UNICODE
    if ( (c = *p) == '\\' && *(p+1) == '\\' && *(p+2) == '?' && *(p+3) == '\\' ) p += 4;
#endif
    while( (c = *p) != 0 ) {
        if ( c == '*' || c == '?' ) {
            return 1;
        } else if ( iskanji(c) ) {
            if ( *(p + 1) != 0 ) p++;
        }
        p++;
    }
    return 0;
}

int _tmain(int argc,_TCHAR *argv[])
{
    int sts;
    int i;
    int g;
    _TCHAR *dir;
#ifdef WIN32
    WIN32_FIND_DATA FindFileData;
    HANDLE hFind;
#else
    struct find_t FindFileData;
#endif
    int newargc;
    _TCHAR **newargv;
    struct arglink {
      struct arglink *next;
      _TCHAR *arg;
    } *linkp,*p,*q;

/*
    _tprintf(_T("main:%d\n"),argc);
    for ( i = 0 ; i < argc ; i++ ) {
        _tprintf(_T("%d %s\n"),i,argv[i]);
    }
*/

    pgname = argv[0];
/*
    _tprintf(_T("%s Copyright (C) 2002-2005 VA007219.\n"),pgname);
*/
    g = 0;
    for ( i = 1 ; i < argc ; i++ ) {
        if ( ckglob(argv[i]) ) {
            g = 1;
            break;
        }
    }
    if ( g == 0 ) {
        sts = globmain(argc,argv);
    } else {
        linkp = malloc(sizeof(struct arglink));
        q = linkp;
        q->arg = argv[0];
        newargc = 1;
        for ( i = 1 ; i < argc  ; i++ ) {
            if ( !ckglob(argv[i]) ) {
                p = malloc(sizeof(struct arglink));
                p->arg = argv[i];
                q->next = p;
                q = p;
                newargc++;
            } else {
#ifdef WIN32
                if ( (hFind = FindFirstFile(argv[i],&FindFileData)) == INVALID_HANDLE_VALUE )
#else
                if ( _dos_findfirst(argv[i],_A_NORMAL | _A_HIDDEN | _A_SYSTEM | _A_SUBDIR,&FindFileData) != 0 )
#endif
                {
                    p = malloc(sizeof(struct arglink));
                    p->arg = argv[i];
                    q->next = p;
                    q = p;
                    newargc++;
/*
                    _ftprintf(errout,_T("%s: %s: argument not matched.\n"),pgname,p->arg);
                    return 1;
*/
                } else {
                    dir = dirname(argv[i]);
                    do {
#ifdef WIN32
                        if ( _tcscmp(FindFileData.cFileName,_T(".")) == 0 || _tcscmp(FindFileData.cFileName,_T("..")) == 0 ) continue;
#else
                        if ( _tcscmp(FindFileData.name,_T(".")) == 0 || _tcscmp(FindFileData.name,_T("..")) == 0 ) continue;
#endif
                        p = malloc(sizeof(struct arglink));
#ifdef WIN32
                        p->arg = newname(dir,FindFileData.cFileName);
#else
                        p->arg = newname(dir,FindFileData.name);
#endif
                        q->next = p;
                        q = p;
                        newargc++;
                    }
#ifdef WIN32
                      while ( FindNextFile(hFind,&FindFileData) != 0 );
#else
                      while ( _dos_findnext(&FindFileData) == 0 );
#endif
                    free(dir);
                }
#ifdef WIN32
                FindClose(hFind);
#else
#ifdef FINDCLOSE
                _dos_findclose(&FindFileData);
#endif
#endif
            }
        }
        newargv = malloc(newargc * sizeof(_TCHAR *));
        p = linkp;
        for ( i = 0 ; i < newargc ; i++ ) {
            newargv[i] = p->arg;
            p = p->next;
        }
        sts = globmain(newargc,newargv);
     /* free() linkp without argv[*] */
     /* free(newargv); */
    }
    return sts;
}
