/* Copyright (C) 2006-2007 VA007219 */
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <windows.h>
#include <tchar.h>

int dbgprintf(_TCHAR *fmt,...);

int std_istalpha(int c)
{
    if ( c < 0 || c >= 128 ) return 0;
    return _istalpha(c);
}

#ifdef _UNICODE
int uwrite(_TCHAR *buffer, int size, int len, FILE *fp)
{
    int mode;
    int sts;
    int i;
    int n;
    int m;
    _TCHAR c;
    _TCHAR *p;
    _TCHAR *q;
    _TCHAR obuffer[1024*2];

    n = size * len;
    if ( n <= 0 ) return 0;
    fflush(fp);
    mode = _setmode(_fileno(fp), _O_BINARY);
    if ( mode == _O_BINARY ) {
        sts = fwrite(buffer, size, len, fp);
        return sts;
    }
    p = buffer;
    q = obuffer;
    m = 0;
    for ( i = 0 ; i < len ; i++ ) {
        c = *p;
        if ( c == '\n' ) {
            *q = '\r';
            q++;
            m++;
        }
        *q = c;
        p++;
        q++;
        m++;
    }
/*
dumpn((unsigned char *)buffer,size * len);
dumpn((unsigned char *)obuffer,size * m);
*/
    sts = fwrite(obuffer, size, m, fp);
    fflush(fp);
    mode = _setmode(_fileno(fp), _O_TEXT);
    return sts;
}

int u_ftprintf(FILE *fp,const _TCHAR *format,...)
{
    va_list argp;
    int ret = 0;
static _TCHAR buffer[1024 + LONGMAX_PATH];
    DWORD len;
    DWORD NumberOfCharsWritten;
    BOOL sts;
    HANDLE h;
    int type = 0;

    if ( fp == stdout || fp == stderr ) {
        h = GetStdHandle(fp == stdout ? STD_OUTPUT_HANDLE : STD_ERROR_HANDLE);
        if ( h != INVALID_HANDLE_VALUE ) {
            if ( GetFileType(h) == FILE_TYPE_CHAR ) {
                type = 1;
            }
        }
    }
    if ( format != NULL && *format != 0 ) {
        va_start(argp, format);
        if (  type == 1 ) {
            ret = len = _vsntprintf(buffer, sizeof buffer / sizeof buffer[0], format, argp);
            if ( len > 0 ) {
                sts = WriteConsole(h, buffer, len, &NumberOfCharsWritten, NULL);
                if ( sts == 0 ) ret = -1;
            }
        } else {
#if 0
            ret = _vftprintf(fp, format, argp);
#else
            ret = len = _vsntprintf(buffer, sizeof buffer / sizeof buffer[0], format, argp);
            if ( len > 0 ) {
                sts = uwrite(buffer, sizeof(_TCHAR), len, fp);
            }
buffer[len] = 0;
/*OutputDebugString(buffer);*/
#endif
        }
        va_end(argp);
    }
    return ret;
}
#ifndef GUISUB
int u_tprintf(const _TCHAR *format,...)
{
    va_list argp;
    int ret = 0;
static _TCHAR buffer[1024 + LONGMAX_PATH];
    DWORD len;
    DWORD NumberOfCharsWritten;
    BOOL sts;
    HANDLE h;
    int type = 0;
int i;

        h = GetStdHandle(STD_OUTPUT_HANDLE);
        if ( h != INVALID_HANDLE_VALUE ) {
            if ( GetFileType(h) == FILE_TYPE_CHAR ) {
                type = 1;
            }
        }

    if ( format != NULL && *format != 0 ) {
        va_start(argp, format);
        if (  type == 1 ) {
            ret = len = _vsntprintf(buffer, sizeof buffer / sizeof buffer[0], format, argp);
            if ( len > 0 ) {
                sts = WriteConsole(h, buffer, len, &NumberOfCharsWritten, NULL);
                if ( sts == 0 ) ret = -1;
            }
        } else {
#if 0
/*dbgprintf(_T("format=%s\n"),format);
*/
            ret = _vftprintf(stdout, format, argp);
#else
            ret = len = _vsntprintf(buffer, sizeof buffer / sizeof buffer[0], format, argp);
            if ( len > 0 ) {
                sts = uwrite(buffer, sizeof(_TCHAR), len, stdout);
            }
/*
buffer[len] = 0;
OutputDebugString(buffer);
*/
#endif
        }
        va_end(argp);
    }
    return ret;
}
#endif
#endif

#ifdef DEBUG

FILE *loglog = NULL;

void dumpn(unsigned char *buff,unsigned n)
{
    int i;

    if ( loglog == NULL ) loglog = fopen("log.log","a");
    i = 0;
    while ( n ) {
        if ( i == 0 ) {
            fprintf(loglog,":%x  ",buff);
        }
        fprintf(loglog,"%02x ",*buff++);
        i++;
        if ( i == 16 ) {
            fprintf(loglog,"\n");
            i = 0;
        }
        n--;
    }
    fprintf(loglog,"\n");
}
#endif
